/*
**
** pouzitie:
**
** dostane 3 argumenty: 
** argv[1]: vstup
** argv[2]: vzorovy vystup
** argv[3]: jeho vystup
**
** navratova hodnota: 
**
** 0: OK
** hocico ine: wrong answer
**
** na stdout vypise druh chyby
*/


#include <stdio.h>
#include <list>

#define MAXN 300000

using namespace std;

list<int> graph[MAXN];
int n,m;
int farba[MAXN];

int main(int argc, char **argv)
{
//    printf("testovac begin...");
    FILE *in, *out;
    int i,a,b;
    int d;

    list<int>::iterator it;
    
    if (argc != 4) {
        fprintf(stderr, "Wrong usage.\n");
        return 2;
    }

    in=fopen(argv[1], "r");
    out=fopen(argv[3], "r");

    if (in == 0 || out == 0) {
        fprintf(stderr, "Can't open %s or %s\n", argv[1], argv[3]);
        return 3;
    }

    fscanf(in, "%d%d",  &n, &m);
    for (i = 0; i < m; i++) {
        fscanf(in, "%d%d", &a, &b);
        a--;b--;
        graph[a].push_front(b);
        graph[b].push_front(a);
    }

    if (fgetc(out) == 'I') {
            fprintf(stderr, "Allegedly impossible.\n");
            return 2;
    }
    rewind(out);
    for (i = 0; i < n; i++) {
        if (fscanf(out,"%d", &d) != 1) {
            fprintf(stderr, "Format error.\n");
            return 2;
        }
        if (d > 5 || d < 1) {
            fprintf(stderr, "Format error.\n");
            return 2;
        }
        farba[i]=d;
    }

    fscanf(out," ");
    if (!feof(out)) {
        fprintf(stderr,"Garbage after end.\n");
        return 2;
    }

    for (i = 0; i < n; i++) {
        for (it=graph[i].begin(); it != graph[i].end(); it++) {
            if (farba[i] == farba[*it]) {
                fprintf(stderr, "Improper coloring.\n");
                return 1;
            }
        }
    }
    
    fclose(in);
    fclose(out);

    fprintf(stdout, "OK\n");

//    printf("done\n");

    return 0;
}
